# Alpine
CTN_NAME="toolbox"
CTN_PORT=$(get_podcfg $CTN_NAME CTN_PORT)
CTN_IMAGE=$(get_podcfg $CTN_NAME CTN_IMAGE)
CTN_SRC=$(get_podcfg $CTN_NAME CTN_SRC)
CTN_JENKINS_TIMEOUT_S=$(get_podcfg $CTN_NAME CTN_JENKINS_TIMEOUT_S)
CTN_PORT_AGENT=$(get_podcfg $CTN_NAME CTN_PORT_AGENT)
CTN_INTERNAL_PORT=$(get_podcfg $CTN_NAME CTN_INTERNAL_PORT)

pod_run() {
    j_file="agent.jar"
    j_name="$(get_podcfg $CFG_DOMAIN_TESTSRV CTN_NAME)"
    j_server="$j_name.$DOMAIN_NAME:$(get_podcfg $CFG_DOMAIN_TESTSRV CTN_INTERNAL_PORT)/$j_name"
    j_url="$j_server/jnlpJars/$j_file"
    j_path="/home/jenkins"
    mkdir -p $CFG_LIVE_DATA $CFG_SHARE_DIR
    podman run --dns=$DNS_CTN_IP --dns=$GATEWAY_IP --memory $CTN_MEM \
               --name $CTN_NAME --hostname $CTN_NAME --network=$NETWORK_NAME -u 0 --detach --no-hosts \
               -v "$COMMON_ETC_HOSTS":/etc/hosts \
               -v "$CFG_LIVE_DATA/$(get_podcfg nginx CTN_WORKDIR)/certs":/tools/certs \
               -v "$CFG_SHARE_DIR":/shared \
               -v "$POD_ROOT/.includes/tools/":/tools \
               --cap-add=NET_ADMIN --cap-add=NET_RAW \
               -it \
    $CTN_SRC/$CTN_IMAGE \
    bash -c "test -f $j_path/$j_file ||
             timeout $CTN_JENKINS_TIMEOUT_S \
             bash -c 'while ! jar -tf $j_path/$j_file ]]; do sleep 1; rm -f $j_path/$j_file; curl -sO $j_url; done';
             mv $j_path/$j_file $j_path/agent/$j_file;
             nohup java -jar $j_path/agent/$j_file -noCertificateCheck \
                        -jnlpUrl http://$j_server/computer/toolbox%2Dagent/jenkins-agent.jnlp \
                        -secret 6b66d3e4e46d2c05b5ae43eec77d1133f7fe7e50dc1c7e36166444d870f01f4d -workDir '' \
             &> $j_path/agent/agent.log& /bin/bash"
}

# Remote configuration jobs (// tasks after containers run())
pod_config() {
    # 1) Add packages
    add_pkg_to_ctn ${CTN_NAME} "python3 wget dnsutils iputils-ping sendmail"
}

pod_post_config() {
    # 2) Generate certs for https domain url
    _extra_gen_ssl_key_cmd="if ! ls *.pem &>/dev/null; then cd /tools/certs; ../generate_certs.sh $DOMAIN_NAME; else true; fi"
    # Uncomment the next line to use the domain name configured in config.sh
    #_extra_gen_ssl_key_cmd="if ! ls *.pem; then cd /tools/certs; ../generate_certs.sh $DOMAIN_NAME; else true; fi"
    add_setup_cmd_to_ctn ${CTN_NAME}  "$_extra_gen_ssl_key_cmd" "nginx certificates available" nginx
}
